//+------------------------------------------------------------------+
//|                                           SuperTrend signals.mq4 |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 LimeGreen
#property indicator_color2 PaleVioletRed
#property indicator_width1 3
#property indicator_width2 3


extern int    period          = 10;
extern int    appliedPrice    = PRICE_CLOSE;
extern double multiplier      = 2.4;

//
//
//
//
//

double arrUp[];
double arrDn[];
double Direction[];
double Up[];
double Dn[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(5);
      SetIndexBuffer(0, arrUp); SetIndexStyle(0,DRAW_ARROW); SetIndexArrow(0,159);
      SetIndexBuffer(1, arrDn); SetIndexStyle(1,DRAW_ARROW); SetIndexArrow(1,159);
      SetIndexBuffer(2, Direction);
      SetIndexBuffer(3, Up);
      SetIndexBuffer(4, Dn);

      SetIndexLabel(0,"SuperTrend up");
      SetIndexLabel(1,"SuperTrend down");
   IndicatorShortName("SuperTrend");
   period = MathMax(1,period);
}
int deinit() { return(0); }




//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars = IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
           int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
      
      for(int i = limit; i >= 0; i--)
      {
         double atr    = iATR(NULL,0,period,i);
         double cprice = iMA(NULL,0,1,0,MODE_SMA,appliedPrice,i);
         double mprice = (High[i]+Low[i])/2;
             Up[i]  = mprice+multiplier*atr;
             Dn[i]  = mprice-multiplier*atr;
             Direction[i] = Direction[i+1];
               if (cprice > Up[i+1]) Direction[i] =  1;
               if (cprice < Dn[i+1]) Direction[i] = -1;
             arrUp[i] = EMPTY_VALUE;
             arrDn[i] = EMPTY_VALUE;
               if (Direction[i] > 0) { Dn[i] = MathMax(Dn[i],Dn[i+1]); if (Direction[i] != Direction[i+1]) arrUp[i] = Dn[i];}
               else                  { Up[i] = MathMin(Up[i],Up[i+1]); if (Direction[i] != Direction[i+1]) arrDn[i] = Up[i];}
      }
      return(0);
}

